var Gtop = Gtop || {};

Gtop.RecommendMovies = function(args) {
    Useless.HttpRequestJSON.call(this, args);
    var _curDateTime = null;
    var _movieList = null;

    Object.defineProperties(this, {
        curDateTime: {
            get: function () { return _curDateTime; }
            , set: function (value) { _curDateTime = value; }
        },
        movieList: {
            get: function () { return _movieList; }
            , set: function (value) { _movieList = value; }
        }
    });
};
Gtop.RecommendMovies.prototype = new Useless.HttpRequestJSON({});
Gtop.RecommendMovies.prototype = {
    getMovieList: function (callback) {
        var tempFunc = function () {
            var returnArray = [];
            if (this.responseJSON !== null) {
                var data = this.responseJSON;
                data = this.sortDateTime(data, 'recommend_movie_date');

                for (var index = 0; index < data.length; index++) {
                    // var targetDate = new Date(data[index].recommend_movie_date);
                    var targetDate = this.convertDateObject(data[index].recommend_movie_date);
                    if (targetDate.getFullYear() === this.curDateTime.getFullYear() && targetDate.getMonth() === this.curDateTime.getMonth() && targetDate.getDate() === this.curDateTime.getDate()) {
                        var dataB = data[index].movies;
                        dataB = this.sortDisplayOrder(dataB);
                        for (var indexB = 0; indexB < dataB.length; indexB++) {
                            // var startTime = new Date(targetDate.toLocaleDateString()+' '+dataB[indexB].recommend_movie_broadcast_start_time);
                            var timeStartStamps = dataB[indexB].recommend_movie_broadcast_start_time.split(':');
                            var startTime = new Date(
                                targetDate.getFullYear()
                                , targetDate.getMonth()
                                , targetDate.getDate()
                                , Number(timeStartStamps[0])
                                , Number(timeStartStamps[1])
                            );
                            
                            // var endTime = new Date(targetDate.toLocaleDateString()+' '+dataB[indexB].recommend_movie_broadcast_start_time);
                            var timeEndStamps = dataB[indexB].recommend_movie_time_scale.split(':');
                            var endTime = new Date(
                                targetDate.getFullYear()
                                , targetDate.getMonth()
                                , targetDate.getDate()
                                , Number(timeEndStamps[0])
                                , Number(timeEndStamps[1])
                            );
                                            
                            // var addTime = dataB[indexB].recommend_movie_time_scale.split(':');
                            // endTime.setHours(startTime.getHours()+Number(addTime[0]));
                            // endTime.setMinutes(startTime.getMinutes()+Number(addTime[1]));
                            if (startTime.getTime() <= this.curDateTime.getTime() && this.curDateTime.getTime() < endTime.getTime()) {
                                returnArray.push({
                                    display_order: dataB[indexB].display_order
                                    , m_program_id: dataB[indexB].m_program_id
                                    , m_program_title: dataB[indexB].m_program_title
                                    , new_window_st: dataB[indexB].new_window_st
                                    , recommend_movie_broadcast_start_time: dataB[indexB].recommend_movie_broadcast_start_time
                                    , recommend_movie_description: dataB[indexB].recommend_movie_description
                                    , recommend_movie_display_judge: dataB[indexB].recommend_movie_display_judge
                                    , recommend_movie_image: dataB[indexB].recommend_movie_image
                                    , recommend_movie_movie_url: dataB[indexB].recommend_movie_movie_url
                                    , recommend_movie_time_scale: dataB[indexB].recommend_movie_time_scale
                                    , recommend_movie_title: dataB[indexB].recommend_movie_title
                                    , recommend_movie_url: dataB[indexB].recommend_movie_url
                                });
                            }
                        }
                    }
                }
            }
            this.movieList = returnArray;
            callback();
        }
        this.done(tempFunc.bind(this));
    },

    sortDisplayOrder: function (data) {
        data.sort(function(a,b){
            if(Number(a.display_order) < Number(b.display_order)) return -1;
            if(Number(a.display_order) > Number(b.display_order)) return 1;
            return 0;
        });
        return data;
    },

    sortDateTime: function (data, key, asc) {
        ascFlag = (asc !== undefined ? asc: 'ASC');
        if (ascFlag === 'DESC') {
            data.sort(function(a,b){
                var dateA = this.convertDateObject(a[key]);
                var dateB = this.convertDateObject(b[key]);
                if(dateA.getTime() < dateB.getTime()) return 1;
                if(dateA.getTime() > dateB.getTime()) return -1;
                return 0;
            }.bind(this));
            return data;
        } else {
            data.sort(function(a,b){
                var dateA = this.convertDateObject(a[key]);
                var dateB = this.convertDateObject(b[key]);
                if(dateA.getTime() > dateB.getTime()) return 1;
                if(dateA.getTime() < dateB.getTime()) return -1;
                return 0;
            }.bind(this));
            return data;
        }
    },

    convertDateObject: function (stringDateTime) {
        var pattern = '';
        var result = null;
        
        pattern = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})\+(\d{2})(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2]) - 1
                , Number(result[3])
                , Number(result[4]) + Number(result[7])
                , Number(result[5]) + Number(result[8])
                , Number(result[6])
            );
            return updateDate;
        }

        pattern = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2})\+(\d{2}):(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2])-1
                , Number(result[3])
                , Number(result[4]) + Number(result[6])
                , Number(result[5]) + Number(result[7])
            );
            return updateDate;
        }

        pattern = /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2])-1
                , Number(result[3])
                , Number(result[4])
                , Number(result[5])
                , Number(result[6])
            );
            return updateDate;
        }

        pattern = /^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})$/;
        result = stringDateTime.match(pattern);
        if (result !== null) {
            var updateDate = new Date(
                Number(result[1])
                , Number(result[2])-1
                , Number(result[3])
                , Number(result[4])
                , Number(result[5])
            );
            return updateDate;
        }
    }
};